"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransformerInterceptor = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const lodash_1 = require("lodash");
const rxjs_1 = require("rxjs");
const meta_storage_1 = require("../meta-storage/meta-storage");
let TransformerInterceptor = class TransformerInterceptor {
    constructor(_moduleRef) {
        this._moduleRef = _moduleRef;
    }
    intercept(context, next) {
        return next.handle().pipe((0, rxjs_1.map)((body) => {
            const _body = (0, lodash_1.cloneDeep)(body);
            this._inPlaceTransform(_body);
            return _body;
        }));
    }
    _inPlaceTransform(object) {
        if ((0, lodash_1.isArray)(object)) {
            object.forEach((_obj) => this._inPlaceTransform(_obj));
        }
        if (!(0, lodash_1.isObject)(object)) {
            return object;
        }
        const metarecords = meta_storage_1.MetaStorage.instance().findTransformerMetadata(object.constructor);
        if (!metarecords) {
            return object;
        }
        metarecords.forEach((metarecord) => {
            const transformer = this._moduleRef.get(metarecord.transformer);
            object[metarecord.propertyName] = transformer.transform({
                key: metarecord.propertyName,
                obj: object,
                options: metarecord.options,
                value: object[metarecord.propertyName],
            });
            const nested = (0, lodash_1.values)((0, lodash_1.pickBy)(object, lodash_1.isObject));
            this._inPlaceTransform(nested);
        });
    }
};
TransformerInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.ModuleRef])
], TransformerInterceptor);
exports.TransformerInterceptor = TransformerInterceptor;
